dmraid45 target please

Bug #97655 reported by Chad Bernier
34
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Wishlist
Unassigned
Nominated for Hardy by Jochen Schneider
linux-source-2.6.20 (Ubuntu)
Wishlist
Unassigned
Nominated for Hardy by Jochen Schneider
linux-source-2.6.22 (Ubuntu)
Undecided
Unassigned
Nominated for Hardy by Jochen Schneider

Bug Description

Can you please enable the dmraid45 patch? The one that creates dm-raid4-5.ko? I wouldn't mind resulting module being in a seperate deb file, if you won't include it with the kernel. It's extremely important.

Revision history for this message
Chad Bernier (berniercr) wrote :

http://people.redhat.com/~heinzm/sw/dm/dm-raid45/

This is where the patch for 2.6.18 is located. I need someone to rewrite the patch for kernel 2.6.20, as the author hasn't done so yet.

Daniel T Chen (crimsun)
Changed in linux-source-2.6.20:
importance: Undecided → Wishlist
status: Unconfirmed → Confirmed
Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

This patch is from Mandriva 2007.1 (Spring?) Development, it's not (yet) included in CD/DVD Images.
Apply the next patch too - for build fixes.

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

As promised: here comes the 2nd patch.

A big "THANK YOU" to Mandriva!

Revision history for this message
Chad Bernier (berniercr) wrote :

thank you for making that effort Tom. I tried finding that patch myself but it didn't work. Guess what? It still doesn't work. Here's what happens when I try to build it. I hope the patch only needs minor corrections.

  CC drivers/md/dm-raid4-5.o
drivers/md/dm-raid4-5.c: In function ‘wake_do_raid_delayed’:
drivers/md/dm-raid4-5.c:542: warning: passing argument 1 of ‘cancel_delayed_work’ from incompatible pointer type
drivers/md/dm-raid4-5.c:545: warning: passing argument 2 of ‘queue_delayed_work’ from incompatible pointer type
drivers/md/dm-raid4-5.c: In function ‘raid_set_check_and_degrade’:
drivers/md/dm-raid4-5.c:735: warning: format ‘%llu’ expects type ‘long long unsigned int’, but argument 4 has type ‘sector_t’
drivers/md/dm-raid4-5.c: In function ‘do_recovery’:
drivers/md/dm-raid4-5.c:2599: warning: format ‘%llu’ expects type ‘long long unsigned int’, but argument 4 has type ‘sector_t’
drivers/md/dm-raid4-5.c: In function ‘rs_workqueue_init’:
drivers/md/dm-raid4-5.c:3168: warning: assignment from incompatible pointer type
drivers/md/dm-raid4-5.c: In function ‘dev_parms’:
drivers/md/dm-raid4-5.c:3230: warning: format ‘%llu’ expects type ‘long long unsigned int *’, but argument 3 has type ‘sector_t *’
drivers/md/dm-raid4-5.c:3230: warning: format ‘%llu’ expects type ‘long long unsigned int *’, but argument 3 has type ‘sector_t *’
drivers/md/dm-raid4-5.c: In function ‘raid_devel_stats’:
drivers/md/dm-raid4-5.c:3731: warning: format ‘%llu’ expects type ‘long long unsigned int’, but argument 4 has type ‘region_t’
drivers/md/dm-raid4-5.c:3731: warning: format ‘%llu’ expects type ‘long long unsigned int’, but argument 6 has type ‘region_t’
drivers/md/dm-raid4-5.c:3731: warning: format ‘%llu’ expects type ‘long long unsigned int’, but argument 7 has type ‘region_t’
drivers/md/dm-raid4-5.c: In function ‘raid_status’:
drivers/md/dm-raid4-5.c:3789: warning: format ‘%llu’ expects type ‘long long unsigned int’, but argument 5 has type ‘sector_t’
  CC drivers/md/dm-mem-cache.o
  CC drivers/md/dm-region_hash.o
  LD drivers/md/built-in.o
drivers/md/dm-mem-cache.o: In function `pl_elem':
/usr/src/linux/drivers/md/dm-mem-cache.h:20: multiple definition of `pl_elem'
drivers/md/dm-raid4-5.o:/usr/src/linux/drivers/md/dm-mem-cache.h:20: first defined here
make[3]: *** [drivers/md/built-in.o] Error 1
make[2]: *** [drivers/md] Error 2
make[1]: *** [drivers] Error 2
make[1]: Leaving directory `/usr/src/linux-source-2.6.20'
make: *** [debian/stamp-build-kernel] Error 2

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

Hi Chad,

the patch(es) worked for me without a glitch. What kernel version did you use?
Here's my command history ...

 1. apt-get install linux-source build-essential bin86 libncurses-dev kernel-package
 2. pushd /usr/src/
 3. tar xjf linux-source-2.6.20.tar.bz2
 4. ln -s linux-source-2.6.20 linux
 5. pushd linux
 6. cp /boot/config-$(uname -r) .config
 7. make oldconfig
 8. wget -q -O - http://librarian.launchpad.net/7394177/linux-2.6-dm-raid45.patch | patch -p1
 9. wget -q -O - http://librarian.launchpad.net/7394193/linux-2.6-dm-raid45-buildfix.patch | patch -p1
10. make menuconfig # enable "RAID4/5 target (EXPERIMENTAL) (NEW)" in "Device drivers" -> "Multi-device support (RAID and LVM)"
11. make-kpkg clean
12. make-kpkg --initrd --revision=dmraid45 kernel_image
13. popd
14. dpkg -i linux-image-2.6.20.3-ubuntu1_dmraid45_i386.deb
15. popd

Good luck!

Revision history for this message
Chad Bernier (berniercr) wrote :

i tried to compile it into the kernel. I think it must be left as a module.

I got it to compile as a module, but it still isn't working. Dmraid is hanging as the other bug states. I still get a lot of errors about the actual drives but that's another problem too. more to the actual point.

root@jp-super:/dev/.static/dev/mapper# dmraid -ay
RAID set "nvidia_edjdcidj" already active
ERROR: opening "/dev/.static/dev/mapper/nvidia_edjdcidj"

i get this error when trying to activate the raid. The devices do not show up in /dev/mapper/ even though it says the set is active.

Revision history for this message
Chad Bernier (berniercr) wrote :

i don't think this is a problem with the raid45 patch right?

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

Hi Chad,

i don't know what's the problem is. My hardware is a GigaByte GA-965P-DS3P (rev2.0) mainboard with ICH8R. dmraid just works ...
But I didn't do a real stress-testing or run any heavy workloads. Just partitioning and copying.

[We proprably need to contact Heinz Mauelshagen - the writer of the dmraid45 code]

Revision history for this message
Chad Bernier (berniercr) wrote :

he didn't respond when i tried contacting him, maybe he'll listen to you. I'm using an nvidia chipset. I took his 2.6.18 patch and applied it to a 2.6.19 kernel. it patched everything except one file, which i manually fixed. That worked, but i want to use a 2.6.20 kernel.

It stopped working in that kernel at some point, but i since fixed dmraid, so maybe it'll work. i removed the kernel, but still have the deb files. I'll reinstall the kernel and see if it's at least working with that one.

Revision history for this message
Chad Bernier (berniercr) wrote :

it is not working anymore. This must be a bug in dmraid or something. thanks for the patch.

Revision history for this message
Matt Royal (spiffy-robinson+launchpad) wrote :

Hi Thomas,
   I think that I'm in the same boat as Chad, and haven't been able to get dmraid working with my Raid5 array. When I run `dmraid -ay` I get the following error:

         ERROR: device-mapper target type "raid45" not in kernel

   The step-by-step instructions you gave above were very helpful, and I was able to successfully compile a patched kernel. Unfortunately, I'm still getting the above error with the patched kernel. Also, dmraid causes my computer to hang when it boots, produces an error, and then boot continues normally ( Sorry, I don't have the boot error text ). I'm running the amd64 version of feisty: could this be part of the problem?

   I'm not sure if this is helpful, but here is the output of `dmraid -r`:

         /dev/sda: sil, "sil_ahadeadefbab", raid5_ls, ok, 586070830 sectors, data@ 0
         /dev/sdb: sil, "sil_ahadeadefbab", raid5_ls, ok, 586070830 sectors, data@ 0
         /dev/sdc: sil, "sil_ahadeadefbab", raid5_ls, ok, 586070830 sectors, data@ 0

   Do you have any suggestions on what I could try next?

Revision history for this message
Chad Bernier (berniercr) wrote :

I got past those problems and am having different ones now, as my bug reports show.

you are still getting the raid45 error? Are you certain that the dm-raid4-5 module is compiled AND loaded?

Revision history for this message
Matt Royal (spiffy-robinson+launchpad) wrote :

I've never had to deal this closely with the kernel before, so perhaps I'm missing something. I haven't done anything related to raid45 except the 15 steps that Thomas gave. Is there something else I need to be doing beyond installing dmraid and booting with the patched kernel? Please pardon my newb-ness.

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

Hi Folks,

Matt: looking at your error message I would say you have not loaded the module ("/sbin/modprobe dm-raid4-5"), have you? What's the output of dmesg and lsmod?
I'm currently working on a Ubuntu 7.04 based LiveCD with dmraid45 support - but it's way to big (>800mb) and doesn't fit on a cd ... if it's done I will try find a place
from where you guys can download it.

Cheers.
Thomas

Revision history for this message
Chad Bernier (berniercr) wrote :

take something out of the CD, maybe Open office. It can be installed after the install. I'd rather be missing something than waste a DVD.

Revision history for this message
nox216 (nox216) wrote :

Also, it should be noted that it's looking like Fedora Core 7 will include a new release candidate for dmraid -- rc14 (http://rpmfind.net/linux/RPM/fedora/devel/i386/dmraid-1.0.0.rc14-2.fc7.i386.html).

Seeing as the author of dmraid is associated with Red Hat, and the release date for FC 7 is later this month (http://fedoraproject.org/wiki/Releases/7/Schedule), I'd say we've got decents odds on there being kernel support set up in FC7 as well as the next release of dmraid working properly with said support.

Hopefully Ubuntu can copy some of this by Gutsy?

Revision history for this message
Lesley McDowell (lesleymcdowell) wrote :

As you can see, I am having the same issues. I am working from the Ubuntu 7.04 Live CD. I have worked on this for a week and I am about to pull my hair out. Thomas Bitterman, have you finished the Live CD with raid45 support? I don't care if it's a DVD iso. I am desperate at this point and I don't want to give up.

root@ubuntu:~# dmraid -r
/dev/sda: isw, "isw_gegiebbhb", GROUP, ok, 976773165 sectors, data@ 0
/dev/sdb: isw, "isw_gegiebbhb", GROUP, ok, 976773165 sectors, data@ 0
/dev/sdc: isw, "isw_gegiebbhb", GROUP, ok, 976773165 sectors, data@ 0
root@ubuntu:~# dmraid -ay
ERROR: device-mapper target type "raid45" not in kernel
root@ubuntu:~#

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

I've done the LiveCD and at least it boots. I couldn't test it any further - my raid 5 volume is broken. (bad memory module)
So please make a backup before you try it!

Revision history for this message
Lesley McDowell (lesleymcdowell) wrote : Re: [Bug 97655] Re: dmraid45 target please

You are my hero! I am downloading it now and I will try to install Feisty
tonight on my raid5. I will let you know the results.

Thanks again!!

On 5/8/07, Thomas Bittermann <email address hidden> wrote:
>
> I've done the LiveCD and at least it boots. I couldn't test it any
> further - my raid 5 volume is broken. (bad memory module)
> So please make a backup before you try it!
>
> ** Attachment added: "stripped down Ubuntu 7.04 LiveCD with dmraid &
> dm-raid4-5.ko support"
> http://librarian.launchpad.net/7581962/feisty%2Bdmraid45.iso
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

see patches & livecd iso

Changed in linux-source-2.6.20:
status: Confirmed → In Progress
Changed in linux-source-2.6.20:
assignee: nobody → launchpad-cobonet
Revision history for this message
Lesley McDowell (lesleymcdowell) wrote :

Going through the install it didn't detect the raid 5. I manually ran
dmraid -ay and received the same error about the raid45 kernel. Do I need
to insmod or modprobe in order for it to work?

On 5/9/07, Thomas Bittermann <email address hidden> wrote:
>
> see patches & livecd iso
>
> ** Changed in: linux-source-2.6.20 (Ubuntu)
> Status: Confirmed => In Progress
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Lesley McDowell schrieb:
> Going through the install it didn't detect the raid 5. I manually ran
> dmraid -ay and received the same error about the raid45 kernel. Do I need
> to insmod or modprobe in order for it to work?
Yes, please try the following:
1. sudo modprobe dm-raid4-5
Should load the kernel module, check dmesg for a line like
"[...] device-mapper: dm-raid45: : initialized v0.1444" and
lsmod

2. sudo dmraid -r
You should see now a list of raid drives and the raid volume(s).

3. sudo dmraid -ay
Should activate your volume(s), again check dmesg.

Cheers.
Thomas
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.5 (MingW32)
Comment: Using GnuPG with Mozilla - http://enigmail.mozdev.org

iD8DBQFGQjTY3E3TGgPB70IRAiE1AKDJWkiXlIBZLzHodM47IzHGQs4R3wCgsYWW
Bt9Bij74XdP2ET8dGNFcPLo=
=5Eqb
-----END PGP SIGNATURE-----

Revision history for this message
Chad Bernier (berniercr) wrote :

Thank you Tom for doing this for us and for Ubuntu. I hope someone picks up my other bugs, because my raid set won't activate properly.

lesley, It sounds like you want to BOOT off your raid5. That isn't going to happen, not anytime soon. I hope you can get it working as a data drive though. To be able to boot of raid5, first the initrd needs to be fixed to include dmraid in it and whatnot. After that's done though, grub still needs to be patched. I might be wrong, but I am under the impression that Grub cannot boot off a raid5 array, although it will work on a raid0. I hope I'm wrong about that, and full raid5 support can be added to gutsy, and will be included in FC7.

Revision history for this message
Chad Bernier (berniercr) wrote :

I decided to test the live cd. That'll tell me if there is a problem with the module or dmraid, or if i screwed something up with udev, right?

Revision history for this message
Lesley McDowell (lesleymcdowell) wrote :

That's good to know. I was about to pull my hair out. I am building a HTPC
machine and wanted raid 5 for redundancy. Looks like I will have to use
raid 0 and backup the important stuff on a regular basis.

Again, thank you for the info.

On 5/9/07, Chad Bernier <email address hidden> wrote:
>
> Thank you Tom for doing this for us and for Ubuntu. I hope someone
> picks up my other bugs, because my raid set won't activate properly.
>
> lesley, It sounds like you want to BOOT off your raid5. That isn't
> going to happen, not anytime soon. I hope you can get it working as a
> data drive though. To be able to boot of raid5, first the initrd needs
> to be fixed to include dmraid in it and whatnot. After that's done
> though, grub still needs to be patched. I might be wrong, but I am
> under the impression that Grub cannot boot off a raid5 array, although
> it will work on a raid0. I hope I'm wrong about that, and full raid5
> support can be added to gutsy, and will be included in FC7.
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Revision history for this message
Tormod Volden (tormodvolden) wrote :

> the initrd needs to be fixed to include dmraid

With the dmraid package installed, the initrd will include dmraid as well. To include any special modules like dmraid4-5.ko, edit /usr/share/initramfs-tools/hooks/dmraid and run "sudo update-initramfs -u" afterwards.

To find out if grub needs patching, boot grub (e.g. from a floppy or grub cd) and see if you can find the boot partition using the grub commands "find" or "root".

Revision history for this message
Chad Bernier (berniercr) wrote :

Lesley, I'm not sure if you can get the boot to work or not, but that isn't your only option. You could simple use an additional Hard drive to boot from, and keep all your data on the raid5 array. That's what I'm attempting to do with this computer as it simplifies the installation of any OS. You won't have redundancy on your OS, but do you really need that? You can just set up a cron job or something to automatically backup your boot drive to the array anyways. The downside is you'll need to get another drive and have room in your case for it. I don't know if that's a deal breaker for you.

Revision history for this message
Lesley McDowell (lesleymcdowell) wrote :

Yeah. The case only holds 3 drives and currently I have 3 500 GB drives
installed. Is there a way to raid partitions on each drive? Such as Raid 0
for the root and /home for the raid5 across the 3 drives?

On 5/10/07, Chad Bernier <email address hidden> wrote:
>
> Lesley, I'm not sure if you can get the boot to work or not, but that
> isn't your only option. You could simple use an additional Hard drive
> to boot from, and keep all your data on the raid5 array. That's what
> I'm attempting to do with this computer as it simplifies the
> installation of any OS. You won't have redundancy on your OS, but do
> you really need that? You can just set up a cron job or something to
> automatically backup your boot drive to the array anyways. The downside
> is you'll need to get another drive and have room in your case for it. I
> don't know if that's a deal breaker for you.
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Revision history for this message
Chad Bernier (berniercr) wrote :

Oh yea, Tom, your livecd doesn't work for me.

First, a small comment. It would be better if you included dm-raid4-5 on the initrd so people don't have to manually load it, quick fix.

Secondly, I loaded the module, all went fine. dmraid -s shows my array just fine. But when i run dmraid -ay, nothing happens. the process hangs. After a few minutes and attempts to kill the running process, the whole computer freezes up. Even before then, a new terminal window can not be opened. I did this twice.

Revision history for this message
Chad Bernier (berniercr) wrote :

Yea i figured something like a HTPC might have space limitations. Lesley, unfortunately, the only way to do what you described involves giving up Windows. I have assumed you want windows along with Ubuntu on your PC, because you are using dmraid. If you won't be installing windows, you don't need fake raid at all. you can use software raid already built into linux. That will allow you to set up a raid 0 and raid 5 on the same array, pretty cool :)

Revision history for this message
Lesley McDowell (lesleymcdowell) wrote :

I don't want or have windows installed. My original intent was to install
Ubuntu with LinuxMCE on a raid 5 configuration. I tried using software raid
but had issues on setting it up in the Ubuntu setup. When I choose create
md devices it says I only have 1 raid partition when it needs a minumum of
3. That's why I headed down the dmraid path. So you are telling me it can
be done as long as it's only a linux machine? That is great news. I guess
I will try again this evening when I get home from work.

On 5/10/07, Chad Bernier <email address hidden> wrote:
>
> Yea i figured something like a HTPC might have space limitations.
> Lesley, unfortunately, the only way to do what you described involves
> giving up Windows. I have assumed you want windows along with Ubuntu on
> your PC, because you are using dmraid. If you won't be installing
> windows, you don't need fake raid at all. you can use software raid
> already built into linux. That will allow you to set up a raid 0 and
> raid 5 on the same array, pretty cool :)
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Revision history for this message
Chad Bernier (berniercr) wrote :

Yes, i know it can be done, I've heard of that awhile ago. I don't think the Ubuntu installer is very good at that yet. You'll probably have to manually create a bunch of partitions and everything. I haven't been able to play with software raid myself because I always needed windows on my desktops. If you look around the internet, you should be able to find a guide.

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

Hi Folks,

I have some news from Heinz Mauelshagen. Although he's currently working on other things, he's also trying to improve dmraid45. The following issues are on his roadmap:
 - i/o optimizations (he even tries to make it faster than md-raid45)
 - bug fixing
 - a new stable patch

I told him about the LiveCD and all you guys waiting for a solution and now he thinks about releasing the patch sooner (but not that stable) - so we all could help hunting down the bug(s).

Cheers.
Thomas

Revision history for this message
dawid (tuxdawid) wrote :

Hello,

First of all, excuse me for my english : I'am french and I didn't speak english since 1991 (at school).

I wanted to tell you that the ubuntu livecd dmraid45 didn't boot on my computer, with 3 sata disks in RAID5.
When the RAID is not activate, I have not any problem.

My motherboard is a Gigabyte M61P-S3 with a nForce 430 chipset.

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

Hi,

there is now an updated patch for kernel 2.6.22 available:
https://www.redhat.com/archives/dm-devel/2007-July/msg00099.html

I'm running it on amd64 (ICH8R with 4 SATA disks as RAID5/RAID0 "matrix RAID") using NTFS and EXT3 as filesystems.
With the previous patch and 2.6.18 kernel I couldn't get EXT3 to work reliably, but no such problems with 2.6.22 so far.

Revision history for this message
Martin Seidel (streifenkarl) wrote :

Hi guys,

i downloaded the patch for kernel 2.6.22 in the posting above. How can I install it? It is a *.patch file.
thanks
Martin

Revision history for this message
CoolkcaH (coolkcah) wrote :

Do we really need to patch the kernel or is it possible to compile a module?

Is there hope that it will be included in gutsy?
I will have a new computer next week with 3 disks so I want to use raid5 and dual-boot windows. Maybe I will just hold with windows until gutsy arrives.

Matti, are you using 2.6.22 with feisty?

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

I don't think there's currently easy way to avoid patching the kernel to get dmraid45. I'm using a custom "non-official" 2.6.22 kernel with gutsy, but a 2.6.22 kernel most likely works fine also with feisty.

Revision history for this message
Zach Retzlaff (zach-retzlaff) wrote :
Download full text (6.7 KiB)

Thanks to all who have diligently posted on this bug, and thanks in advance to anyone who can offer me further assistance. I have only been able to get as far as patching (I think) Linux kernel 2.6.22.1 with Heinz Mauleshagen's dm-raid45-2.6.22.1 patch.

Kernel Source:
http://www.kernel.org/pub/linux/kernel/v2.6/linux-2.6.22.1.tar.bz2

dmraid45 Post and Patch Source from Heinz Mauelshagen:
https://www.redhat.com/archives/dm-devel/2007-July/msg00099.html
http://people.redhat.com/heinzm/sw/dm/dm-raid45/dm-raid45-2.6.22.1-20070724.patch.bz2

Kernel Patching How-To Followed:
http://www.howtoforge.com/kernel_compilation_ubuntu
* I skipped the step on re-linking /bin/sh from /bin/dash to /bin/bash, as I didn't think this was necessary. Am I wrong?

My custom 2.6.22.1 kernel ("custom kernel") has been installed, more or less successfully from what I can tell. I have omitted all wireless networking modules from the compilation, which I don't think should have any impact on the issue at hand.

These are the issues:

1. Booting to my custom kernel fails while initializing dmraid, and I have to boot to my previous kernel instead (2.6.18-generic), remove dmraid, then boot back to my custom kernel for further troubleshooting.
2. "dmraid -r" shows my installed devices, but "dmraid -ay" returns the all too common " "raid45" not in kernel" error.
3. modprobe on any combination of dm-raid4-5, dm-raid45, dmraid45, etc. of course returns "Module <xyz> not found."
4. "dmesg | grep raid" returns "...raid45: unknown target type".
5. "lsmod | grep raid" or just manually scanning the results of lsmod returns nothing related to dmraid or my raid devices.

I think that's a fairly complete synopsis. Here is my configuration, followed by some (hopefully) useful output...

Config:

Mobo: ASUS M2NPV-VM AM2 NVIDIA GeForce 6150 (NB GeForce 6150, SB nForce 430) on-board support configured for RAID5.
CPU/RAM: Adequate / N/A
Boot HDD: Pri Master IDE
RAID Config: Athena Power 5.25" Backplane, supports quad 2.5" SATA drives.
RAID HDD's: 4 TOSHIBA MK1637GSX 160GB 5400 RPM 8MB Cache SATA 3.0Gb/s Notebook Hard Drives

The RAID HDD's are detected in gparted as unallocated, and parted returns the following for all four drives (/dev/sda - sdd):

"Error: Unable to open /dev/sd[a-d] - unrecognised disk label."

Useful Output:

root@IN-FS-N01:~# dmraid -r
/dev/sda: nvidia, "nvidia_cgcdfabe", raid5_ls, ok, 312581806 sectors, data@ 0
/dev/sdb: nvidia, "nvidia_cgcdfabe", raid5_ls, ok, 312581806 sectors, data@ 0
/dev/sdc: nvidia, "nvidia_cgcdfabe", raid5_ls, ok, 312581806 sectors, data@ 0
/dev/sdd: nvidia, "nvidia_cgcdfabe", raid5_ls, ok, 312581806 sectors, data@ 0

root@IN-FS-N01:~# dmraid -ay
ERROR: device-mapper target type "raid45" not in kernel

root@IN-FS-N01:~# modprobe dm-raid45
FATAL: Module dm_raid45 not found.
root@IN-FS-N01:~# modprobe dm-raid4-5
FATAL: Module dm_raid4_5 not found.
root@IN-FS-N01:~# modprobe dmraid45
FATAL: Module dmraid45 not found.
root@IN-FS-N01:~# modprobe dmraid
FATAL: Module dmraid not found.

root@IN-FS-N01:~# dmesg | grep raid
[ 9.228000] device-mapper: table: 254:0: raid45: unknown target type
[ 671.080000] device-mapper: table: 254:0...

Read more...

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

Are you sure the dm-raid45 module is enabled ?

Your kernel config should have at least these lines:
CONFIG_MD_RAID456=m
CONFIG_DM_RAID45=m

For the initramfs, I've added the module to the following files:

/usr/share/initramfs-tools/hooks/dmraid

..snip..
manual_add_modules dm-mirror
manual_add_modules dm-raid4-5
copy_exec /sbin/dmraid sbin
..snip..

/usr/share/initramfs-tools/scripts/local-top/dmraid

..snip..
modprobe -Q dm-mirror
modprobe -Q dm-raid4-5

[ -x /sbin/dmraid ] && /sbin/dmraid -ay
..snip..

The devices and partitions show up in directory /dev/mapper, for example:
/dev/mapper/isw_ibcfibahh_RAID0
/dev/mapper/isw_ibcfibahh_RAID01
/dev/mapper/isw_ibcfibahh_RAID02
/dev/mapper/isw_ibcfibahh_RAID5
/dev/mapper/isw_ibcfibahh_RAID51
/dev/mapper/isw_ibcfibahh_RAID52

RAID0 and RAID5 are the names I've given to the raid volumes in BIOS. So in my case I can run "parted /dev/mapper/isw_ibcfibahh_RAID5" to partition the raid5 volume.

When dm-raid4-5 module is loaded on boot, dmesg should show something like this:
[ 50.928873] raid5: automatically using best checksumming function: generic_sse
[ 50.933003] generic_sse: 8728.000 MB/sec
[ 50.933083] raid5: using function: generic_sse (8728.000 MB/sec)
[ 50.935099] device-mapper: dm-raid45: initialized v0.2337
[ 51.329743] device-mapper: dm-raid45: /dev/sda is raid disk 0
[ 51.329832] device-mapper: dm-raid45: /dev/sdb is raid disk 1
[ 51.329917] device-mapper: dm-raid45: /dev/sdc is raid disk 2
[ 51.330003] device-mapper: dm-raid45: /dev/sdd is raid disk 3
[ 51.330090] device-mapper: dm-raid45: 128/128/256 sectors chunk/io/recovery size, 64 stripes
[ 51.330219] device-mapper: dm-raid45: algorithm "xor_asm", 4 chunks with 8625MB/s
[ 51.330343] device-mapper: dm-raid45: RAID5 (left asymmetric) set with net 3/4 devices
[ 51.330500] device-mapper: dm-raid45: No regions to recover

Steps I use install a custom kernel:
1) patch the sources :)
2) copy the .config file from the current kernel and run 'make oldconfig'
3) compile the kernel with 'make-kpkg clean && fakeroot make-kpkg --initrd --append-to-version=-custom kernel_image kernel_headers'
4) install the generated headers and image .deb files (install should automatically run update-initramfs)
5) finally run 'update-grub'

I also get the "no such file directory" messages with update-initramfs and they should be nothing to worry about.

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

And you can of course check if the module has been compiled by running:
find /lib/modules/2.6.22.1-custom/| grep dm-raid
which should return:
/lib/modules/2.6.22.1-custom/kernel/drivers/md/dm-raid4-5.ko

Revision history for this message
Zach Retzlaff (zach-retzlaff) wrote :

Matti,

Thanks for the input! I made the following changes:

Added "CONFIG_DM_RAID45=m" to the config.
Added "manual_add_modules dm-raid4-5" to "/usr/share/initramfs-tools/hooks/dmraid"
Added "modprobe -Q dm-raid4-5" to "/usr/share/initramfs-tools/scripts/local-top/dmraid"

"make menuconfig" seems to run OK, but I get the following warning (also including the context output, warning close to the end):

root@IN-FS-N01:/usr/src/linux# make menuconfig
  HOSTCC scripts/basic/fixdep
  HOSTCC scripts/basic/docproc
  HOSTCC scripts/kconfig/conf.o
  HOSTCC scripts/kconfig/kxgettext.o
  HOSTCC scripts/kconfig/lxdialog/checklist.o
  HOSTCC scripts/kconfig/lxdialog/inputbox.o
  HOSTCC scripts/kconfig/lxdialog/menubox.o
  HOSTCC scripts/kconfig/lxdialog/textbox.o
  HOSTCC scripts/kconfig/lxdialog/util.o
  HOSTCC scripts/kconfig/lxdialog/yesno.o
  HOSTCC scripts/kconfig/mconf.o
  SHIPPED scripts/kconfig/zconf.tab.c
  SHIPPED scripts/kconfig/lex.zconf.c
  SHIPPED scripts/kconfig/zconf.hash.c
  HOSTCC scripts/kconfig/zconf.tab.o
  HOSTLD scripts/kconfig/mconf
scripts/kconfig/mconf arch/i386/Kconfig
.config:1380:warning: trying to reassign symbol DM_RAID45
#
# configuration written to .config
#

Is it necessary to run "make oldconfig"? I tried that after "make clean", but I can't tell if there are any warnings because the output is too long for the terminal session, and I can't pour over all that text manually. Thanks for your assistance.

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

'make oldconfig' just checks any new config options that are available compared to the kernel the .config file is from. You should never edit the .config file manually, always use 'make menuconfig/oldconfig/whateverconfig' for configuring the kernel. Check with 'grep RAID .config' to see that those modules are really enabled.

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

You can find the menuconfig options in Device Drivers -> Multi-device support (RAID and LVM) -> RAID support -> RAID-4/RAID-5/RAID-6 mode and Device mapper support -> RAID 4/5 target (EXPERIMENTAL)

Revision history for this message
Zach Retzlaff (zach-retzlaff) wrote :

Aaaaah, I definitely see why you should never modify the config manually. Forgive me, after 2+ solid years running an Ubuntu box at home, I am still a complete n00b in many situations. This is actually my first time building a custom kernel. ;)

"RAID-4/RAID-5/RAID-6 mode" was already included and I have added "RAID 4/5 target (EXPERIMENTAL)" via menuconfig, as well as "Device mapper debugging support", just in case. Looks like now the config has everything it's supposed to. Whereas I was getting "# CONFIG_DM_RAID45 is not set" previously grepping the config, I now get...

root@IN-FS-N01:/usr/src/linux# grep RAID ./.config
[...cut...]
# Multi-device support (RAID and LVM)
[...cut...]
CONFIG_MD_RAID456=m
CONFIG_MD_RAID5_RESHAPE=y
CONFIG_DM_RAID45=m
[END]

And I no longer receive the warning, ".config:1380:warning: trying to reassign symbol DM_RAID45". ;-P Fantabulous! I'm in the process of compiling the kernel source now, and I will keep you posted on any updates. Thanks!

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

One more thing (since noone has mentioned it in this issue yet :). If you boot from a dmraid volume using grub, you need make sure the option "savedefault" is NOT enabled. Otherwise it will fail to boot with message "Error 15: File not found" or similar.

Revision history for this message
CoolkcaH (coolkcah) wrote :

Thomas are you still working on the live cd? I need it because I don't have any other hard disk to install ubuntu...when you get it to work please report.

Revision history for this message
Thomas Bittermann (pufferbrater) wrote :

CoolkcaH schrieb:
> Thomas are you still working on the live cd? I need it because I don't
> have any other hard disk to install ubuntu...when you get it to work
> please report.
no, i don't - i waited a couple of weeks for the stuff from Heinz - but he was
too busy i guess ...

my raid5 under windows xp is really instable, so i have to do a (really slow)
complete rebuild around twice a month. so i truly don't expect an improved
situation if the whole thing runs under linux.

as a workaround i installed ubuntu under vmware, it worked pretty well and
performance wasn't too bad.

for now i'm going back to raid1 ... sorry and good luck.

Cheers,
Thomas

Revision history for this message
CoolkcaH (coolkcah) wrote :

I noticed it is possible with Intel chipsets to make partitions with
different raid levels.
I will try to make raid0 and raid1 partitions for speed (OS) and
recovery (home) and see if dmraid can see them, it's a good
alternative to raid5.

Or I'll just buy one more hard disk and try to use raid10, or give up
raid and install ubuntu there as a last resort.

On 9/12/07, Thomas Bittermann <email address hidden> wrote:
> CoolkcaH schrieb:
> > Thomas are you still working on the live cd? I need it because I don't
> > have any other hard disk to install ubuntu...when you get it to work
> > please report.
> no, i don't - i waited a couple of weeks for the stuff from Heinz - but he was
> too busy i guess ...
>
> my raid5 under windows xp is really instable, so i have to do a (really slow)
> complete rebuild around twice a month. so i truly don't expect an improved
> situation if the whole thing runs under linux.
>
> as a workaround i installed ubuntu under vmware, it worked pretty well and
> performance wasn't too bad.
>
> for now i'm going back to raid1 ... sorry and good luck.
>
> Cheers,
> Thomas
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Changed in linux-source-2.6.20:
assignee: pufferbrater → nobody
status: In Progress → Confirmed
Revision history for this message
Oli (oli) wrote :

I've got 900gigs of data trapped in a [fake]RAID5 array. I've been following this thread for months because I'm really itching to get off Windows and onto Linux. This is my final deal-breaking hurdle.

I've tried pactching and compiling the latest patch from Heinz but when compiling I hit:
  CC [M] drivers/md/raid10.o
  CC [M] drivers/md/dm-raid1.o
In file included from drivers/md/dm-raid1.c:9:
drivers/md/dm-io.h:84: warning: ‘struct io_control’ declared inside parameter list
drivers/md/dm-io.h:84: warning: its scope is only this definition or declaration, which is probably not what you want
drivers/md/dm-io.h:84: error: conflicting types for ‘dm_io’
drivers/md/dm-io.h:77: error: previous declaration of ‘dm_io’ was here
drivers/md/dm-raid1.c: In function ‘do_write’:
drivers/md/dm-raid1.c:820: warning: passing argument 1 of ‘dm_io’ from incompatible pointer type
drivers/md/dm-raid1.c:820: error: too many arguments to function ‘dm_io’
make[3]: *** [drivers/md/dm-raid1.o] Error 1
make[2]: *** [drivers/md] Error 2
make[1]: *** [drivers] Error 2
make[1]: Leaving directory `/usr/src/linux-source-2.6.22'
make: *** [debian/stamp-build-kernel] Error 2

So yes another error for yet another day. Hoorah. Does anybody know enough about all this to see why that's fouling up so bad? This is my first kernel compile (I tried it twice in case it was me following instructions wrong) so I'm way out of my depth =)

I'm on 2.6.22-14-generic if that makes any difference.

And Zach, did you have any luck? If you did I'd *REALLY* appreciate a kick in the right direction (or a step-by-step). Cheers.

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

Looks like ubuntu includes some other patch which conflicts with the dmraid45 patch. You could try patching a vanilla 2.6.22.x kernel or disabling CONFIG_DM_MIRROR option (if you don't need RAID1).

Revision history for this message
Oli (oli) wrote :

Well I got it to compile into the kernel (I had to move device mapper support into the kernel to do it). Booted to it fine (well except for the graphics meltdown - but oh well =) but I can't get dmraid to list my RAID5 volumes.

My RAID0 stripe is coming through fine but RAID5 is still MIA. I'm not entirely sure how to poke around and try to get this thing finding them but any help is vastly appreciated.

The RAID device is a Sil 3114

Oli (oli)
Changed in linux-source-2.6.22:
status: New → Confirmed
Revision history for this message
Oli (oli) wrote :

Due to the lack of interest and response, I scrapped my RAID. I've since formatted the disks into a RAID5 via mdadm (a much better solution vs a "hardware" FAKERAID chipset)

Revision history for this message
Aron Schatz (aronschatz) wrote :

Can this bug be fixed for Gutsy?

mdadm doesn't work correctly for RAID5 arrays when trying to boot.

Revision history for this message
Oli (oli) wrote :

dmraid and mdadm raid are two completely different modules that are AFAIK completely unrelated. dmraid is for hardware fakeraid while mdadm raid is pure software raid.

I've had similar mdadm raid issues though. I fixed it by running:
sudo dpkg-reconfigure mdadm

Accept the defaults and at the end it should show you that it is writing to a boot image. If that boot image is *not* your current kernel, find your kernel in synaptic (search for "linux-image") and mark it for reinstallation. Then reconfigure mdadm again and it should write to the correct boot image.

This all assumes you've got the correct mdadm config in the first place (correct mdadm.conf settings, valid fstab entry, etc). If you're still stuck, search the forums because there are lots of helpy bits there.

Revision history for this message
alopex (alopex) wrote :

Hey all!
Is there any chance Ubuntu/dmraid supporting fakeRAID5 soon? The bug was reported a half year ago but Gutsy still doesn't seem to support it. I'm new to Linux so I don't like the idea of building my own kernel as a first thing... Nontheless I really want to leave XP...

Revision history for this message
Chad Bernier (berniercr) wrote :

I would be trying to get this fixed too, but I still don't have the
hardware, or know when I'll be getting it. They told me they'd try to have
it done in gutsy. I doubt Hardy will get it, because they will be
concentrating on stability. It could be a long way a ways.

You have a couple of choices. You can try custom compiling and all that
goodness. Or, you could try Fedora or something.

If it were me, I'd install the Hardy development version, and be constantly
fiddling with it trying to get the raid to work. I am more comfortable than
you though. You can leave XP in a dual boot in the meantime, until you're
confident things are working well.

On Nov 30, 2007 7:23 AM, lreinecke <email address hidden> wrote:

> Hey all!
> Is there any chance Ubuntu/dmraid supporting fakeRAID5 soon? The bug was
> reported a half year ago but Gutsy still doesn't seem to support it. I'm new
> to Linux so I don't like the idea of building my own kernel as a first
> thing... Nontheless I really want to leave XP...
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Revision history for this message
Matti Tiainen (mvtiaine) wrote :

Patch for kernel 2.6.23.1 is now available:
http://people.redhat.com/~heinzm/sw/dm/dm-raid45/

Revision history for this message
Leann Ogasawara (leannogasawara) wrote :

The Hardy Heron kernel was recently uploaded for testing if anyone is interested. https://launchpad.net/ubuntu/+source/linux . You'll obviously still have to patch the source. Does anyone have an idea if these patches have been sumitted for inclusion in the mainline kernel? That's the best way to ensure your code makes it into the ubuntu kernel. Thanks.

Changed in linux:
importance: Undecided → Wishlist
status: New → Incomplete
Revision history for this message
Leann Ogasawara (leannogasawara) wrote :

Also just a note that I have opened a new task against the actively developed kernel. However, I'm closing this against linux-source-2.6.20 and linux-source-2.6.22 as this does not meet the criteria for a stable release update. You can learn more about the stable release update process at https://wiki.ubuntu.com/StableReleaseUpdates . Thanks!

Changed in linux-source-2.6.22:
status: Confirmed → Won't Fix
Changed in linux-source-2.6.20:
status: Confirmed → Won't Fix
Revision history for this message
alopex (alopex) wrote :

why would this bug expire? would be nice to have this patched with ubuntu 08.10 at least.

Revision history for this message
Leann Ogasawara (leannogasawara) wrote :

Hi lreinecke,

Please refer to https://help.launchpad.net/BugStatuses .

We still need feedback whether or not this patch has been submitted upstream for inclusion in the mainlin kernel. It is a lot of extra work for the Ubuntu kernel team to maintain out of tree patches. As such they require evidence of upstream submission before considering to maintain community patches locally. Thanks.

Revision history for this message
Kano (master-kanotix) wrote : current patch for 2.6.24

To fully support raid 5 with dmraid you need to update dmraid too. This info is correct:

https://bugs.launchpad.net/ubuntu/+source/linux/+bug/97655/comments/40

But dmraid should be updated to

http://people.redhat.com/heinzm/sw/dmraid/src/dmraid-1.0.0.rc14.tar.bz2

as rc13 segfaults in some cases. The attached patch is for 2.6.24 kernel. Downloaded from:

http://people.redhat.com/~heinzm/sw/dm/dm-raid45/dm-raid45-2.6.24-20080602a.patch.bz2

Revision history for this message
Leann Ogasawara (leannogasawara) wrote :

It doesn't appear that this patch has been submitted upstream yet. I checked both the mainline kernel git tree as well as the latest 2.6.24-mm1 patch set. I'd encourage you to ask the author of the patch to please submit this for inclusion in the upstream kernel. Thanks.

Revision history for this message
Kano (master-kanotix) wrote :

Well you can expect that it is in Fedora. Btw. I forgot to mention that the dmraid initscript should load the same modules like the initramfs variant in case you install it later. It is not fully clear what modules needed to load usually. If you like to contact the author is is very easy to find his mail adress in the code.

Revision history for this message
Derek Seabury (derek-seabury) wrote :

I'm willing to invest some time/effort here but am new to ubuntu/deb have been away from kernel hacking for a while so mileage may vary.

I have pulled down the Hardy Alpha 5 and applied the patch to build dm-raid4-5.ko . I'm getting some weirdness from dmraid, but assuming I get that ironed out is there a way I can move this forward?
- Can I create a version of the patch with no conflicts and submit that for inclusion? Hard to call myself the author for dropping 5 lines but hey...
- Would this require a new bug against linux-source-2.6.24?
- In regard to a LiveCD I have some concern that GRUB might have issues but I could plug away at that next unless it's a fool's errand.

Revision history for this message
Luke Yelavich (themuso) wrote :

This module has been included in the hardy kernel as of 2.6.24-10. Marking as fix released. If anything needs to be done to the dmraid scripts for Ubuntu to make use of this module properly, please let me know, and I can make the changes, and get it uploaded.

Changed in linux:
status: Incomplete → Fix Released
Revision history for this message
MrFuzzemz (mrfuzzemz) wrote :

So then will the Hardy Beta LiveCD that is to be available today allow for management of RAID5 through dmraid? (nvraid included) Thanks.

Revision history for this message
Stavros Korokithakis (stavrosk) wrote :

I am running the Hardy beta at the moment and I can confirm that it doesn't work. This is my output:

user@machine ~> sudo dmraid -va y
ERROR: device-mapper target type "raid45" not in kernel
INFO: Activating GROUP RAID set "isw_bfjhhhjjib"

Revision history for this message
Chad Bernier (berniercr) wrote : Re: [Bug 97655] Re: dmraid45 target please

did you try to load the module first?

sudo modprobe dm-raid4-5 or something like that.

On Sun, Mar 23, 2008 at 7:06 PM, Stavros Korokithakis <
<email address hidden>> wrote:

> I am running the Hardy beta at the moment and I can confirm that it
> doesn't work. This is my output:
>
> user@machine ~> sudo dmraid -va y
> ERROR: device-mapper target type "raid45" not in kernel
> INFO: Activating GROUP RAID set "isw_bfjhhhjjib"
>
> --
> dmraid45 target please
> https://bugs.launchpad.net/bugs/97655
> You received this bug notification because you are a direct subscriber
> of the bug.
>

Revision history for this message
Stavros Korokithakis (stavrosk) wrote :

I'm sorry, I hadn't tried that. It works fine now, thanks. It still needs loading the module and mounting, but I guess this isn't the place for this.

Revision history for this message
MrFuzzemz (mrfuzzemz) wrote :

Stavros--
You may know this already, but in case you don't:

 you can load the module at startup by adding it to:
 /etc/modules

As for mounting at boot, you must add an entry to your
/etc/fstab
This should include the filesystem and read/write permissions.

Hope it helps!
Can you confirm that it is indeed RAID5?

Thanks

Revision history for this message
Stavros Korokithakis (stavrosk) wrote :

Ah, thanks, I didn't know about /etc/modules, I have added it now and it should work (fstab works fine and nautilus recognises it as a location).

It is indeed a RAID5 setup (I have an intel controller), here are the details:

user@machine ~> sudo dmraid -s
*** Group superset isw_bfjhhhjjib
--> Active Subset
name : isw_bfjhhhjjib_RAID5
size : 1953536512
stride : 128
type : raid5_la
status : ok
subsets: 0
devs : 3
spares : 0

user@machine ~> mount
/dev/mapper/isw_bfjhhhjjib_RAID51 on /media/raid type fuseblk (rw,nosuid,nodev,noatime,allow_other,default_permissions,blksize=4096)

I'll be watching this ticket, so just reply here if you want anything else from me.

Thanks again for the help.

Revision history for this message
Aeki (melitta-dragaschnig) wrote :

Hi all,

today I've used the latest 8.04 daily live cd to try and get my RAID5 working, unfortunately unsuccessfully. Here is what I have got

lsmod | grep raid
dm_raid4_5 25984 0
dm_mod 62660 1 dm_raid4_5
raid456 129040 0
md_mod 82068 1 raid456
async_xor 4992 1 raid456
async_memcpy 3712 1 raid456
async_tx 9292 3 raid456,async_xor,async_memcpy
xor 16136 2 raid456,async_xor

sudo dmraid -s
*** Set
name : nvidia_afbcbdef
size : 2344268160
stride : 128
type : raid5_ls
status : ok
subsets: 0
devs : 4
spares : 0

sudo dmraid -r
/dev/sdd: nvidia, "nvidia_afbcbdef", raid5_ls, ok, 781422766 sectors, data@ 0
/dev/sdc: nvidia, "nvidia_afbcbdef", raid5_ls, ok, 781422766 sectors, data@ 0
/dev/sdb: nvidia, "nvidia_afbcbdef", raid5_ls, ok, 781422766 sectors, data@ 0
/dev/sda: nvidia, "nvidia_afbcbdef", raid5_ls, ok, 781422766 sectors, data@ 0

sudo dmraid -ay
ERROR: device-mapper target type "raid45" not in kernel

dmraid -V
dmraid version: 1.0.0.rc14 (2006.11.08)
dmraid library version: 1.0.0.rc14 (2006.11.08)
device-mapper version: unknown

I did paid attention while reading this thread but I couldn't spot what else would be needed to make it work. I'd be grateful for any hints.
Best regards

Revision history for this message
Jochen Schneider (panama-joe) wrote :

Still not working with Hardy beta updated on 2008-04-17.

Revision history for this message
Crimson_Fox (crimson-fox-) wrote :

I just got Hardy to install on an Nvidia Raid 5. Had to use the beta release however, the release candidate as well as the latest daily build (as of 4/20/08) would not work.

Used the following commands with both builds of the live-cd after enabling the universe repository:

apt-get update
apt-get install dmraid
modprobe dm-raid4-5
dmraid -ay

Hardy Beta with Kernel 2.6.24-12: Works!
Hardy RC with Kernel 2.6.24-16: Returns "ERROR: device-mapper target type "raid45" not in kernel"

It would seem that whatever fix made it into 2.6.24-12 was removed from 2.6.24-16.

Revision history for this message
Crimson_Fox (crimson-fox-) wrote : New bug report

I figured since it seems to be a regression on the latest kernel, I'd open up a new bug report (this bug was originally opened for 2.6.20).

https://bugs.launchpad.net/ubuntu/+source/linux/+bug/220493

Revision history for this message
cdavis33 (cdavis33882003) wrote :

Hi everyone,
First off, I'm completely new when it comes to RAID and Linux. But I have an old PC, 4-500GB hard drives and a home network. I would like to setup this computer as a Samba server with RAID5. I have a 40GB hard drive to hold the OS and am ready to get this thing running. I've tried to get things running from reading this post and many, many others with no luck. The closest that I got is having a drive with the following attributes: /dev/md0 (-698707507712.00 B).
I don't know. Is that close? A friend of mine said that I should do a software raid which, from reading this, I've come to understand involves mdadm. I really just lost. I don't care what OS I use, but I'd really like to get into Linux. Another friend said that I should use Ubuntu Server 8.10, but all I found was command line. I've come to realize that he was playing a cruel joke on me. I know Windows very well. But anything server related now-a-days seems to be going with Linux.
Is there a VERY detailed how-to or walk-through that would help me go from where I'm at (or scratch. I really don't care at this point.) to a RAID5 Samba server? Any help would be GREATLY appreciated. Thank you.

Revision history for this message
Oli (oli) wrote : Re: [Bug 97655] Re: dmraid45 target please

I use mdadm. As you'll see from my previous posts in this thread, I had
a lot of problems trying to get my FAKERAID (onboard RAID controller)
working, so I dismantled the array and set up software RAID1 for
my /home partition.

It's not the simplest of things but if you can read and have a good
guide to follow, you can get through it.

Here is one such guide: http://bfish.xaedalus.net/?p=188

I can't stress enough how important it is that you read what's written.
And remember that setting up md-raid, as with any other new RAID array,
you'll lose all the data on the disks.

The advantage of mdraid is clear: flexibility. You can take a mismatch
batch of HDs over various controllers and jam them together. You also
have the option to safely (99% of the time) shrink and grow arrays - a
feature only the most expensive hardware RAID controllers have. But it
comes at the cost of performance. Any (decent) hardware RAID5 controller
will obliterate any software RAID.

Take care.
Oli

On Thu, 2008-07-31 at 01:34 +0000, cdavis33 wrote:
> Hi everyone,
> First off, I'm completely new when it comes to RAID and Linux. But I
> have an old PC, 4-500GB hard drives and a home network. I would like
> to setup this computer as a Samba server with RAID5. I have a 40GB
> hard drive to hold the OS and am ready to get this thing running. I've
> tried to get things running from reading this post and many, many
> others with no luck. The closest that I got is having a drive with the
> following attributes: /dev/md0 (-698707507712.00 B).
> I don't know. Is that close? A friend of mine said that I should do a
> software raid which, from reading this, I've come to understand
> involves mdadm. I really just lost. I don't care what OS I use, but
> I'd really like to get into Linux. Another friend said that I should
> use Ubuntu Server 8.10, but all I found was command line. I've come to
> realize that he was playing a cruel joke on me. I know Windows very
> well. But anything server related now-a-days seems to be going with
> Linux.
> Is there a VERY detailed how-to or walk-through that would help me go
> from where I'm at (or scratch. I really don't care at this point.) to
> a RAID5 Samba server? Any help would be GREATLY appreciated. Thank
> you.

Revision history for this message
Phillip Susi (psusi) wrote :

People please, this is a bug report so comments here need to pertain to the bug being reported. General discussion and help requests should be handled on the forums.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers